/*
 * Go2ProfileDifferenceArea.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2ProfileDifferenceArea.h>
#include <z/zGo2ProfileTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2ProfileDifferenceArea Class 
 */

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_Construct(Go2ProfileDifferenceArea* measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileDifferenceArea output = zNIL; 
    Go2Status status = GO2_OK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2ProfileDifferenceAreaClass))); 

    if (!zSUCCESS(status = Go2ProfileDifferenceArea_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }
    
    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_Init(Go2ProfileDifferenceArea measurement, Go2UInt32 id, Go2Object system)
{
    Go2ProfileDifferenceAreaClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Measurement_Init(measurement, GO2_TYPE_PROFILE_DIFFERENCE_AREA, id, system)); 

    obj->Release = Go2ProfileDifferenceArea_VRelease; 
    obj->Read = Go2ProfileDifferenceArea_VRead; 
    obj->Write = Go2ProfileDifferenceArea_VWrite; 

    zCHECK(Go2ProfileArea_Construct(&obj->area, system));       

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_VRelease(Go2ProfileDifferenceArea measurement)
{
    Go2ProfileDifferenceAreaClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2Object_Destroy(obj->area)); 

    zCHECK(Go2Measurement_VRelease(measurement));  
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_VRead(Go2ProfileDifferenceArea measurement, zXml xml, zXmlItem item)
{
    Go2ProfileDifferenceAreaClass* obj = zHANDLE_POINTER(measurement); 
    zChar* text = zNULL;
    z32u textCapacity = GO2_MEASUREMENT_SOURCE_TEXT_CAPACITY; 

    zXmlItem areaItem = zNIL; 

    zCHECK(Go2Measurement_VRead(measurement, xml, item)); 

    zCHECK(zCalloc(&text, textCapacity, sizeof(zChar)));
    zCHECK(zXml_ChildText(xml, item, "SourceOptions", text, textCapacity)); 
    zCHECK(Go2OptionList_ParseList(text, obj->sourceOptions));  

    zCHECK(zXml_Child32u(xml, item, "Source", &obj->source)); 
    

    zCHECK(!zIS_NIL(areaItem = zXml_Child(xml, item, "Area"))); 
    zCHECK(Go2ProfileArea_Read(obj->area, xml, areaItem)); 

    zCHECK(zXml_Child32u(xml, item, "AbsoluteResult", &obj->absoluteResult)); 

    zCHECK(zFree(text));

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_VWrite(Go2ProfileDifferenceArea measurement, zXml xml, zXmlItem item)
{
    Go2ProfileDifferenceAreaClass* obj = zHANDLE_POINTER(measurement); 
    zXmlItem areaItem = zNIL; 

    zCHECK(Go2Measurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_SetChild32u(xml, item, "Source", obj->source)); 

    zCHECK(zXml_AddItem(xml, item, "Area", &areaItem)); 
    zCHECK(Go2ProfileArea_Write(obj->area, xml, areaItem)); 

    zCHECK(zXml_SetChild32s(xml, item, "AbsoluteResult", obj->absoluteResult)); 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetId(Go2ProfileDifferenceArea measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileDifferenceArea_Id(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_Id(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetName(Go2ProfileDifferenceArea measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name);     
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_Name(Go2ProfileDifferenceArea measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity);     
}

GO2_EXPORT(Go2UInt32) Go2ProfileDifferenceArea_SourceOptionCount(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_SourceOptionCount(measurement);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileDifferenceArea_SourceOptionAt(Go2ProfileDifferenceArea measurement, Go2UInt32 index)
{
    return Go2Measurement_SourceOptionAt(measurement, index);     
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetSource(Go2ProfileDifferenceArea measurement, Go2ProfileSource source)
{
    return Go2Measurement_SetSource(measurement, source);     
}

GO2_EXPORT(Go2ProfileSource) Go2ProfileDifferenceArea_Source(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_Source(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetDecisionMin(Go2ProfileDifferenceArea measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min);     
}

GO2_EXPORT(Go2Double) Go2ProfileDifferenceArea_DecisionMin(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_DecisionMin(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetDecisionMax(Go2ProfileDifferenceArea measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max);     
}

GO2_EXPORT(Go2Double) Go2ProfileDifferenceArea_DecisionMax(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_DecisionMax(measurement);     
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_EnableHold(Go2ProfileDifferenceArea measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileDifferenceArea_HoldEnabled(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_EnableSmoothing(Go2ProfileDifferenceArea measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2ProfileDifferenceArea_SmoothingEnabled(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileDifferenceArea_SmoothingWindowMin(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileDifferenceArea_SmoothingWindowMax(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetSmoothingWindow(Go2ProfileDifferenceArea measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2ProfileDifferenceArea_SmoothingWindow(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2ProfileArea) Go2ProfileDifferenceArea_Area(Go2ProfileDifferenceArea measurement)
{
    Go2ProfileDifferenceAreaClass* obj = zHANDLE_POINTER(measurement); 
    return obj->area;  
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetAbsoluteResult(Go2ProfileDifferenceArea measurement, Go2Bool absoluteResult)
{
    Go2ProfileDifferenceAreaClass* obj = zHANDLE_POINTER(measurement); 

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->absoluteResult = absoluteResult; 
    zCHECK(Go2System_SetModified(obj->system)); 

    return GO2_OK;
}
 
GO2_EXPORT(Go2Bool) Go2ProfileDifferenceArea_AbsoluteResult(Go2ProfileDifferenceArea measurement)
{
    Go2ProfileDifferenceAreaClass* obj = zHANDLE_POINTER(measurement); 
    return obj->absoluteResult;   
}


GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetScale(Go2ProfileDifferenceArea measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2ProfileDifferenceArea_Scale(Go2ProfileDifferenceArea measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetOffset(Go2ProfileDifferenceArea measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2ProfileDifferenceArea_Offset(Go2ProfileDifferenceArea measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileDifferenceArea_LinkOptionCount(Go2ProfileDifferenceArea measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2ProfileDifferenceArea_LinkOptionAt(Go2ProfileDifferenceArea measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_EnableLink(Go2ProfileDifferenceArea measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2ProfileDifferenceArea_LinkEnabled(Go2ProfileDifferenceArea measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2ProfileDifferenceArea_SetLink(Go2ProfileDifferenceArea measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2ProfileDifferenceArea_Link(Go2ProfileDifferenceArea measurement) 
{
    return Go2Measurement_Link(measurement); 
}
